commit aa65e962391bb45772500622b689c02a3a82996a
Author: freddy77 <freddy77>
Date:   Mon Feb 23 16:08:33 2009 +0000

    fix core in SQLXxxDescRec

diff --git a/ChangeLog b/ChangeLog
index 69f8006..5ffb819 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Mon Feb 23 17:07:41 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/odbc.c: applied patch by Amir Shamsuddin to fix core
+
 Wed Feb 11 15:39:34 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/ctlib/unittests/Makefile.am src/dblib/unittests/Makefile.am:
 	* src/odbc/unittests/Makefile.am src/tds/unittests/Makefile.am:
@@ -1306,4 +1309,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2727 2009/02/11 14:40:15 freddy77 Exp $
+$Id: ChangeLog,v 1.2728 2009/02/23 16:08:33 freddy77 Exp $
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index ff298b0..04a556b 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -60,7 +60,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.508 2008/12/17 11:04:34 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.509 2009/02/23 16:08:34 freddy77 Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv);
@@ -2199,12 +2199,12 @@ SQLSetDescRec(SQLHDESC hdesc, SQLSMALLINT nRecordNumber, SQLSMALLINT nType, SQLS
 		ODBC_RETURN(desc, SQL_ERROR);
 	}
 
-	if (nRecordNumber > desc->header.sql_desc_count || nRecordNumber < 0) {
+	if (nRecordNumber > desc->header.sql_desc_count || nRecordNumber <= 0) {
 		odbc_errs_add(&desc->errs, "07009", NULL);
 		ODBC_RETURN(desc, SQL_ERROR);
 	}
 
-	drec = &desc->records[nRecordNumber];
+	drec = &desc->records[nRecordNumber - 1];
 
 	/* check for valid types and return "HY021" if not */
 	if (desc->type == DESC_IPD) {
@@ -2257,12 +2257,12 @@ SQLGetDescRec(SQLHDESC hdesc, SQLSMALLINT RecordNumber, SQLCHAR * Name, SQLSMALL
 		ODBC_RETURN(desc, SQL_ERROR);
 	}
 
-	if (RecordNumber > desc->header.sql_desc_count || RecordNumber < 0) {
+	if (RecordNumber > desc->header.sql_desc_count || RecordNumber <= 0) {
 		odbc_errs_add(&desc->errs, "07009", NULL);
 		ODBC_RETURN(desc, SQL_ERROR);
 	}
 
-	drec = &desc->records[RecordNumber];
+	drec = &desc->records[RecordNumber - 1];
 
 	if ((rc = odbc_set_string(Name, BufferLength, StringLength, tds_dstr_cstr(&drec->sql_desc_name), -1)) != SQL_SUCCESS)
 		odbc_errs_add(&desc->errs, "01004", NULL);

